﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class GoUp : MonoBehaviour {

	SpriteRenderer sr;
	public float alpha = 0;
	public AnimationCurve animationCurve;
	public float animationTime;
	public float height;
	float animationTimer = 0;

	public bool show = false;
	Vector3 startPos;

	// Use this for initialization
	void Start () {
		sr = GetComponent<SpriteRenderer>();
		sr.color = new Color(1,1,1,0f);
		startPos = transform.position;
	}
	
	// Update is called once per frame
	void Update () {
		if (show && alpha < 1) {
			alpha += Time.deltaTime;
			if (alpha >= 1) alpha = 1;
			sr.color = new Color(1,1,1,alpha);
		}
		else if (!show && alpha > 0) {
			alpha -= Time.deltaTime;
			if (alpha <= 0) alpha = 0;
			sr.color = new Color(1,1,1,alpha);
		}

		if (alpha > 0) {
			animationTimer += Time.deltaTime;
			if (animationTimer > animationTime) animationTimer = 0;

			float val = animationTimer/animationTime;
			val = animationCurve.Evaluate(val);
			transform.position = new Vector3(startPos.x, startPos.y + val*height, startPos.z);
		}
	}

	public void ShowArrow(bool enable) {
		show = enable;
	}
}
