﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class CameraMovement : MonoBehaviour {

	public float cameraLowest = 1.3f;
	public float cameraHighest = 2.6f;
	public float highestChangeSpeed;
	public float treshold;

	public AnimationCurve ySensitivity;

	public float cameraHidden = 1.9f;

	public float cameraLeft = -0.2f;
	public float cameraRight = 0.2f;

	public float xSpeed;
	public float ySpeed;

	// Hide
	public Slider attention;
	float hidden, gain;
	public float detectionSpeed;
	public float coolDownSpeed;
	public bool locked = false;
	public static CameraMovement cam;

	public float neverLooked = 3;

	Vector3 mouseLastPos;
	Vector3 mousePos;

	CTRL ctrl;

	// Use this for initialization
	void Start () {
		mouseLastPos = Input.mousePosition;

		Cursor.lockState = CursorLockMode.Confined;

		ctrl = GameObject.Find("CTRL").GetComponent<CTRL>();

		StartCoroutine("StartGame");

		cam = this;
	}
	
	// Update is called once per frame
	void Update () {
		if (!locked) {
			mousePos = Input.mousePosition;

			float xx, yy, cx, cy;
			xx = mousePos.x / Screen.width;
			yy = mousePos.y / Screen.height;
			if (ctrl.gameState == CTRL.GameState.Begin) {
				yy = Mathf.Clamp (yy, 0, treshold);
			}

			#region arrow tooltip
			if (ctrl.gameState == CTRL.GameState.Game) {
				if (yy > treshold) {
					if (neverLooked != 0) {
						if (GameObject.Find("Icon_Arrow").GetComponent<GoUp>().show == true) {
							GameObject.Find("Icon_Arrow").GetComponent<GoUp>().show = false;
						}
					}
					neverLooked = 0;
				}

				if (neverLooked > 0) {
					neverLooked -= Time.deltaTime;

					if (neverLooked <= 0) {
						GameObject.Find("Icon_Arrow").GetComponent<GoUp>().ShowArrow(true);
						neverLooked = -1;
					}
				}
			}
			#endregion

			yy = ySensitivity.Evaluate (yy);

			cx = Mathf.Lerp (cameraLeft, cameraRight, xx);
			cy = Mathf.Lerp (cameraLowest, cameraHighest, yy);

			transform.position = new Vector3 (cx, cy, transform.position.z);
		}
	}

	IEnumerator StartGame() {
		yield return new WaitForSeconds(5);
		//ctrl.gameState = CTRL.GameState.Game;
	}

	void FixedUpdate (){
		// Handeling her overwhelming attention

		if (ctrl.spottingCounter > 0 && ctrl.gameState == CTRL.GameState.Game) {
			hidden = transform.position.y - cameraLowest / cameraHighest - cameraLowest;  // How hidden you are between 0 and 1

			gain = (hidden * 2 - 1);
			if (gain < 0) {
				gain *= coolDownSpeed;
			}
			else {
				if (gain < 0.3f) {
					if (Random.Range(0,100) < 2) {
						ctrl.AttentionParticle();
					}
				}
				else {
					if (Random.Range(0,100) < 10) {
						ctrl.AttentionParticle();
					}
				}

				gain *= detectionSpeed;
			}
			ctrl.herAttention = Mathf.Clamp01 (ctrl.herAttention + gain);

			if (ctrl.herAttention >= 1) {
				ctrl.gameState = CTRL.GameState.End;
				ctrl.her.SetTalking(false);
				Sound.play.lose.Play();
				ctrl.her.ChangeSprites("spotted", null);
				GameObject.Find("Endings").GetComponent<Endings>().Spottet();
			}

			//print ("attention: " + ctrl.herAttention);
		} else {
			gain = -1 * coolDownSpeed;

			ctrl.herAttention = Mathf.Clamp01 (ctrl.herAttention + gain);
		}

		attention.value = ctrl.herAttention * 100;
	}
}
