﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ChatManager : MonoBehaviour {

	public char printEmoticonChar;
	char[] placeHolderChars = { 'a', 'b', 'c' };
	public GameObject placeHolderSprite;

	public GameObject textBubblePlayerPrefab;
	public GameObject textBubbleFriendPrefab;
	public GameObject emoticonPrefab;
	public GameObject textMessagePrefab;
	public Transform rightTopCorner;
	CTRL controller;



	public static string PLAYER_STRING = "player";
	public static string FRIEND_STRING = "friend";

	public float zPos;
	public float xPosPlayerCursor;
	public float xPosFriendCursor;


	public float yPosCursor;

	public float emoticonSize = 0.1f; //x-distance between emoticons
	public float yEmotionOffset = 0.35f;
	public float yOffset = 0.5f; //how much lower the next message gets displayed
	public float xOffset = 2; //distance from left to right of the textDisplay
	public float xOffsetFromBorder = 0.1f;


	// Use this for initialization
	void Start () {

		controller = GameObject.FindGameObjectWithTag ("GameController").GetComponent<CTRL>();
		yPosCursor = rightTopCorner.position.y;
		zPos = rightTopCorner.position.z;
		xPosFriendCursor = rightTopCorner.position.x + 3 * xOffsetFromBorder;
		xPosPlayerCursor = rightTopCorner.position.x + xOffset - xOffsetFromBorder;


		createMessage ("ES funktioniert Bruh!", FRIEND_STRING);
	
	}
	
	// Update is called once per frame
	void Update () {
		
		//TODO: delete test method
		//adds 1 emoticon for player when press "a"
		//adds 1 emoction for friend when press "d"
		if (Input.GetKeyDown(KeyCode.A)) {
			Debug.Log ("pressed A");
			createMessage(placeHolderChars, PLAYER_STRING);
		}
		if (Input.GetKeyDown(KeyCode.D)) {
			Debug.Log ("pressed D");
			createMessage(placeHolderChars, FRIEND_STRING);
		}
		
	}


	//for text message
	public GameObject createMessage (string message, string fromWho) {
		GameObject textBubble = createTextBubble(yPosCursor, fromWho);


		createTextUI (yPosCursor, message, textBubble.transform);

		yPosCursor -= yOffset;
		Debug.Log ("new yPosCursor: " + yPosCursor);
		return textBubble;
	}


	//for emoticons message
	public GameObject createMessage (char[] emoticonChars, string fromWho) {
		GameObject textBubble = createTextBubble(yPosCursor, fromWho);
		//position the emoticons
		float xPos = 666;
		if (fromWho == PLAYER_STRING) {
			xPos = xPosPlayerCursor - emoticonChars.Length * emoticonSize;

			foreach (char emoChar in emoticonChars) {
				createSprite(xPos, yPosCursor, emoChar, textBubble.transform);
				xPos += emoticonSize;
			}
		} else if (fromWho == FRIEND_STRING) {
			xPos = xPosFriendCursor;
		}

		yPosCursor -= yOffset;
		Debug.Log ("new yPosCursor: " + yPosCursor);
		return textBubble;
	}


	// creates text message 
	private GameObject createTextUI (float y, string messageString, Transform parent) {
		//TODO: implement
		GameObject textNew = (GameObject) Instantiate(textMessagePrefab, new Vector3(xPosFriendCursor, y -yEmotionOffset, zPos -0.02f), Quaternion.identity, parent);

		textNew.GetComponent<TextMesh> ().text = messageString;

		return textNew;
	}

	private GameObject createTextBubble(float y, string fromWho) {
		GameObject spriteNew;
		if (fromWho == PLAYER_STRING) {
			spriteNew = (GameObject)Instantiate (textBubblePlayerPrefab, new Vector3 (rightTopCorner.position.x, y - yOffset, zPos), Quaternion.identity, transform);
		} else {
			spriteNew = (GameObject)Instantiate (textBubbleFriendPrefab, new Vector3 (rightTopCorner.position.x, y - yOffset, zPos), Quaternion.identity, transform);
		}
		return spriteNew;
	}

	//veraltet
	private GameObject createSprite(float x, float y, char emoticonChar){

		GameObject spriteNew = (GameObject) Instantiate(emoticonPrefab, new Vector3(x, y -yOffset, zPos), Quaternion.identity, transform);

		Sprite charSprite = getSpriteFromChar (emoticonChar);
		spriteNew.GetComponent<SpriteRenderer> ().sprite = charSprite;
		return spriteNew;

	}

	private GameObject createSprite(float x, float y, char emoticonChar, Transform parent){

		GameObject spriteNew = (GameObject) Instantiate(emoticonPrefab, new Vector3(x, y -yEmotionOffset, zPos), Quaternion.identity, parent);

		Sprite charSprite = getSpriteFromChar (emoticonChar);
		if (spriteNew.GetComponent<SpriteRenderer>() != null)
			spriteNew.GetComponent<SpriteRenderer> ().sprite = charSprite;
		return spriteNew;
	}


	//abstrahiert wie CTRL skript das dictionary speichert
	private Sprite getSpriteFromChar(char emoticonChar) {
		return controller.spritesDictionary [emoticonChar];
	}


}
