﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ChatManager_v2 : MonoBehaviour {

	char[] placeHolderChars = { 'a', 'b', 'c' };

	public GameObject textBubblePlayerPrefab;
	public GameObject textBubbleFriendPrefab;
	public GameObject textBigBubblePrefab;
	public GameObject emoticonPrefab;
	public GameObject textMessagePrefab;
	public Transform rightTopCorner;
	//public Sound sound;
	CTRL controller;

	public static string PLAYER_STRING = "player";
	public static string FRIEND_STRING = "friend";

	public float zPos;
	public float yPosCursor;
	public float xPos;

	[Header("y Offset")]
	public float emoticonSize = 0.2f; //x-distance between emoticons
	public float yEmotionOffset = 0.35f; //offset for where to spawn emotiocon
	public float yTextOffset = 0.3f; //offset for where to spawn text
	public float yTextBonusOffset = 0.3f;
	public float yOffsetSmall = 0.4f; //how much lower the next message gets displayed
	public float yOffsetBig = 0.6f;
	public int maxCharsPerLine = 20;

	[Header("x Offset")]
//	public float xOffset = 2; //distance from left to right of the textDisplay
	public float xOffsetPlayerBubble = 0.2f;
	public float xOffsetPlayerFirstEmoticon = 0.65f;
	public float xOffsetFriendBubble = -0.2f;
	public float xOffsetFriendFirstEmoticon = 0.3f;
	public float xOffsetFriendText = 0.3f;


	// Use this for initialization
	void Start () {

		controller = GameObject.FindGameObjectWithTag ("GameController").GetComponent<CTRL>();
		yPosCursor = rightTopCorner.position.y;
		zPos = rightTopCorner.position.z;
		xPos = rightTopCorner.position.x;

	}

	// Update is called once per frame
	void Update () {

		//TODO: delete test method
		//adds 1 emoticon for player when press "a"
		//adds 1 emoction for friend when press "d"
		/*if (Input.GetKeyDown(KeyCode.Q)) {
			Debug.Log ("pressed Q");
			createMessage ("balabdlandddf", FRIEND_STRING);
		}
		if (Input.GetKeyDown(KeyCode.E)) {
			Debug.Log ("pressed E");
			createMessage ("balabdlandddf \n ldkfalöölsdjfl", FRIEND_STRING);
		}
		if (Input.GetKeyDown(KeyCode.A)) {
			Debug.Log ("pressed A");
			createMessage(placeHolderChars, PLAYER_STRING);
		}
		if (Input.GetKeyDown(KeyCode.D)) {
			Debug.Log ("pressed D");
			createMessage(placeHolderChars, FRIEND_STRING);
		}*/

	}


	//for text message
	public GameObject createMessage (string message, string fromWho) {
		GameObject textBubble;
		Sound.play.recieve.Play ();

		if (!message.Contains("\n")) {
			yPosCursor -= yOffsetSmall;
			textBubble = createTextBubble(yPosCursor, fromWho);
			createTextUI (yPosCursor, message, textBubble.transform);

		} else {
			yPosCursor -= yOffsetBig;
			textBubble = createTextBigBubble(yPosCursor, fromWho);
			createTextUI (yPosCursor + yTextBonusOffset, message, textBubble.transform);

		}


		//Debug.Log ("new yPosCursor: " + yPosCursor);
		return textBubble;
	}


	//for emoticons message
	public GameObject createMessage (char[] emoticonChars, string fromWho) {
		yPosCursor -= yOffsetSmall;
		GameObject textBubble = createTextBubble(yPosCursor, fromWho);

		//positions the first emoticons
		float xPosCurrent = 666;
		if (fromWho == PLAYER_STRING) {
			Sound.play.send.Play ();
			xPosCurrent = xPos + xOffsetPlayerFirstEmoticon;

		} else if (fromWho == FRIEND_STRING) {
			Sound.play.recieve.Play ();
			xPosCurrent = xPos + xOffsetFriendFirstEmoticon;
		}

		foreach (char emoChar in emoticonChars) {
			createSprite(xPosCurrent, yPosCursor, emoChar, textBubble.transform);
			xPosCurrent += emoticonSize;
		}

		return textBubble;
	}
		
	// creates text message 
	private GameObject createTextUI (float y, string messageString, Transform parent) {
		GameObject textNew = (GameObject) Instantiate(textMessagePrefab, new Vector3(xPos + xOffsetFriendText, y + yTextOffset, zPos -0.02f), Quaternion.identity, parent);

		textNew.GetComponent<TextMesh> ().text = messageString;
		return textNew;
	}


	//TODO: refactor badly implemented
	private GameObject createTextBigBubble(float y, string fromWho) {
		GameObject spriteNew;
		if (fromWho == PLAYER_STRING) {
			spriteNew = (GameObject)Instantiate (textBigBubblePrefab, new Vector3 (xPos + xOffsetPlayerBubble, y, zPos), Quaternion.identity, transform);
		} else {
			spriteNew = (GameObject)Instantiate (textBigBubblePrefab, new Vector3 (xPos + xOffsetFriendBubble, y, zPos), Quaternion.identity, transform);
		}
		return spriteNew;
	}

	private GameObject createTextBubble(float y, string fromWho) {
		GameObject spriteNew;
		if (fromWho == PLAYER_STRING) {
			spriteNew = (GameObject)Instantiate (textBubblePlayerPrefab, new Vector3 (xPos + xOffsetPlayerBubble, y, zPos), Quaternion.identity, transform);
		} else {
			spriteNew = (GameObject)Instantiate (textBubbleFriendPrefab, new Vector3 (xPos + xOffsetFriendBubble, y, zPos), Quaternion.identity, transform);
		}
		return spriteNew;
	}

	private GameObject createSprite(float x, float y, char emoticonChar, Transform parent){

		GameObject spriteNew = (GameObject) Instantiate(emoticonPrefab, new Vector3(x, y +yEmotionOffset, zPos), Quaternion.identity, parent);

		Sprite charSprite = getSpriteFromChar (emoticonChar);
		if (spriteNew.GetComponent<SpriteRenderer>() != null)
			spriteNew.GetComponent<SpriteRenderer> ().sprite = charSprite;
		return spriteNew;
	}


	//abstrahiert wie CTRL skript das dictionary speichert
	private Sprite getSpriteFromChar(char emoticonChar) {
		return controller.spritesDictionary [emoticonChar];
	}


}
