﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class HandController : MonoBehaviour {

	public Transform grid1, grid2;
	public Animator animator;
	public Camera camera;
	public float tollerance;

	Vector3 point1, point2, mouse;

	Vector2 gridSize;

	void FixedUpdate () {
		// Grid Constraint on Screen
		point1 = camera.WorldToScreenPoint (grid1.position);
		point2 = camera.WorldToScreenPoint (grid2.position);
		gridSize = new Vector2 (point2.x - point1.x, point1.y - point2.y); 
		mouse = Input.mousePosition;

		// If the mouse is in the grid
		if (mouse.x > point1.x - tollerance && mouse.x < point2.x + tollerance && mouse.y < point1.y + 70 + tollerance && mouse.y > point2.y - tollerance) {
			animator.SetFloat ("xPosition", (mouse.x - point1.x) / gridSize.x);
			animator.SetFloat ("yPosition", (mouse.y - point2.y) / gridSize.y);
			animator.SetBool ("OnGrid", true);
		} else {
			animator.SetBool ("OnGrid", false);
		}

	}

	void Update (){
		if (Input.GetMouseButtonDown (0)) {
			//print ("click");
			animator.SetTrigger ("Click");
		}
	}

}
