﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


[System.Serializable]
public class Boundary {

	public float xMin;
	public float xMax;
	public float yMin;
	public float yMax;


	public Boundary (float Xmin, float Xmax, float Ymin, float Ymax){
		xMin = Xmin;
		xMax = Xmax;
		yMin = Ymin;
		yMax = Ymax;
	}

	public Boundary( float Ymin, float Ymax) {
		xMin = 0;
		xMax = 0;
		yMin = Ymin;
		yMax = Ymax;

	}



}

public class HandyCameraMovement : MonoBehaviour {

	public float scrollSensivity = 3;
	public Boundary boundary; // stores how far you can scroll down or up;
	public object chatDisplay;

	public ChatManager_v2 chatManager;
	public float minYminBound = -2;

	public float yBoundCameraOffset = 0.35f; //prevents the camera to go to low



	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		scrollChat ();
		updateBoundary ();

		//TODO: delete this debug function
		if (Input.GetKeyDown(KeyCode.S)) {
			Debug.Log ("pressed S");
			jumpToNewestMessage ();
		}
	}

	void scrollChat(){
		float yScroll = Input.GetAxis("Mouse ScrollWheel");
		float newYpos = Mathf.Clamp(transform.position.y + yScroll* scrollSensivity, boundary.yMin, boundary.yMax);

		transform.position = new Vector3 (transform.position.x, newYpos, transform.position.z);
	}

	void updateBoundary() {
		boundary.yMin = Mathf.Min(chatManager.yPosCursor +yBoundCameraOffset, minYminBound);
	}


	public void jumpToNewestMessage(){
		transform.position = new Vector3 (transform.position.x, boundary.yMin, transform.position.z);
	}


}
