﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Intro : MonoBehaviour {

	public IntroMessage[] introduction;

	public int counter = 0;
	int alreadyUsedCounter = 0;

	CTRL ctrl;

	// Use this for initialization
	void Start () {
		ctrl = GameObject.Find("CTRL").GetComponent<CTRL>();

		//EVENTS.MessageHis(introduction[counter].message);
		GameObject.Find("ChatDisplay").GetComponent<ChatManager_v2>().createMessage(introduction[counter].message, "friend");
		StartCoroutine("JumpToBottom");
		if (!introduction[counter].answer) {
			StartCoroutine(SendHisMessage(introduction[counter].duration));
		}

		counter++;

		for (int i = 0; i < introduction.Length; i++) {
			introduction[i].message = introduction[i].message.Replace("NN","\n");
		}
	}
	
	// Update is called once per frame
	void FixedUpdate () {

	}

	IEnumerator SendHisMessage(float time) {
		yield return new WaitForSeconds(time);

		//Debug.Log(counter + ", " + introduction.Length);

		if (counter < introduction.Length) {
			GameObject.Find("ChatDisplay").GetComponent<ChatManager_v2>().createMessage(introduction[counter].message, "friend");
			StartCoroutine("JumpToBottom");
			if (!introduction[counter].answer) {
				StartCoroutine(SendHisMessage(introduction[counter].duration));
			}

			counter++;
		}
		else {
			ctrl.ChangeGameStateToGame();
		}
	}

	public void GetInput(string input) {
		//counter++;
		if (counter < introduction.Length && ctrl.gameState == CTRL.GameState.Begin && introduction[counter-1].answer) {
			bool next = true;

			if (introduction[counter-1].nameOfMessage != "") {
				for (int i = 0; i < ctrl.messages.Length; i++) {
					if (ctrl.messages[i].name == introduction[counter-1].nameOfMessage) {
						Message newMes = new Message(ctrl.messages[i]);
						newMes.emojis = input;
						ctrl.messages[i] = newMes;
					}
					else if (ctrl.messages[i].emojis == input) {	//ALREADY USED
						next = false;
						AlreadayUsed();
					}
				}
			}

			if (next) StartCoroutine(SendHisMessage(introduction[counter].duration));
		}
		//counter++;

		//Debug.Log(counter);
	}

	void AlreadayUsed() {

		switch(alreadyUsedCounter) {
		case 0: StartCoroutine(AlreadyUsedSend("I think we already \nused this emoji :3", 0.5f)); break;
		case 1: StartCoroutine(AlreadyUsedSend("Loool xDDD", 0.5f));
			StartCoroutine(AlreadyUsedSend("We used this emoji \nbefore xD", 1f)); break;
		case 2: StartCoroutine(AlreadyUsedSend("We shouldn't use the \nsame emoji twice", 0.5f));
			StartCoroutine(AlreadyUsedSend("But you can combine it \nwith another one...", 1.5f));
			StartCoroutine(AlreadyUsedSend("if you like this one \nso much ;)", 2.5f));
			StartCoroutine(AlreadyUsedSend("so...", 5f));
			StartCoroutine(AlreadyUsedSend(introduction[counter-1].message, 5.5f)); break;
		case 3: StartCoroutine(AlreadyUsedSend("Select emojis that we \ndidn't used yet, k?", 0.5f)); break;
		case 4: StartCoroutine(AlreadyUsedSend("Hahaha... \nthat's funny...", 0.5f));
			StartCoroutine(AlreadyUsedSend("I'll buy u a drink \nfor ur help, k?", 1.2f));
			StartCoroutine(AlreadyUsedSend("so " + introduction[counter-1].message, 3f)); break;
		case 5: StartCoroutine(AlreadyUsedSend("...", 0.5f));
			StartCoroutine(AlreadyUsedSend("Can I be serious \nfor a moment?", 1.5f));
			StartCoroutine(AlreadyUsedSend("I really want to \nimpress her", 3.5f));
			StartCoroutine(AlreadyUsedSend("and I'm really nervous", 4.5f)); 
			StartCoroutine(AlreadyUsedSend("So plz don't use \nthe same emoji twice", 6.5f));
			StartCoroutine(AlreadyUsedSend("okay then...", 8.5f));
			StartCoroutine(AlreadyUsedSend(introduction[counter-1].message, 9f)); break;
		default:
			float val = Random.value;
			if (val < 0.2f) StartCoroutine(AlreadyUsedSend("wtf dude...", 0.5f));
			else if (val < 0.4f) StartCoroutine(AlreadyUsedSend("u should write notes...", 0.5f));
			else if (val < 0.6f) StartCoroutine(AlreadyUsedSend("com on...", 0.5f));
			else if (val < 0.8f) StartCoroutine(AlreadyUsedSend("whiskas, is it you?", 0.5f));
			else StartCoroutine(AlreadyUsedSend("that's not \nfunny anymore...", 0.5f)); break;
		}

		alreadyUsedCounter++;
	}

	IEnumerator AlreadyUsedSend(string mes, float time) {
		yield return new WaitForSeconds(time);

		GameObject.Find("ChatDisplay").GetComponent<ChatManager_v2>().createMessage(mes, "friend");
		StartCoroutine("JumpToBottom");
	}

	IEnumerator JumpToBottom() {
		yield return new WaitForSeconds(0.05f);

		GameObject.Find("Camera").GetComponent<HandyCameraMovement>().jumpToNewestMessage();
	}
}
