﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Smartphone : MonoBehaviour {

	public Image[] inputArray;
	string input;

	CTRL ctrl;

	// Use this for initialization
	void Start () {
		ctrl = GameObject.Find("CTRL").GetComponent<CTRL>();

		input = "";
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	public void InputEmoji (Sprite sprite) {

		Sound.play.click.Play();

		if (input.Length <= inputArray.Length) {

			for (int i = 0; i < ctrl.sprites.Count; i++) {
				if (ctrl.sprites[i] == sprite) {
					input = input + ctrl.chars[i];
				}
			}

			//Debug.Log(input);
		}

		UpdateInputArray();
	}

	public void Send() {
		if (input.Length > 0) {
			//EVENTS.Reaction(input);
			if (ctrl.gameState == CTRL.GameState.Begin) {
				GameObject.Find("Intro").GetComponent<Intro>().GetInput(input);
			}
			else {
				ctrl.GetInput(input);
			}

			char[] charArray = input.ToCharArray();

			GameObject.Find("ChatDisplay").GetComponent<ChatManager_v2>().createMessage(charArray, "player");
			StartCoroutine("JumpToBottom");

			input = "";

			UpdateInputArray();
		}
	}

	public void Delete() {
		if (input.Length > 0) {
			input = input.Substring(0, input.Length - 1);
		}
		else {
			input = "";
		}

		UpdateInputArray();
	}

	void UpdateInputArray() {
		if (input.Length > 0) {
			for (int i = 0; i < inputArray.Length; i++) {
				if (i < input.Length) {
					char chr = input[i];
					if (ctrl.spritesDictionary.ContainsKey(chr)) {
						inputArray[i].sprite = ctrl.spritesDictionary[input[i]];
					}
					inputArray[i].enabled = true;
				}
				else {
					inputArray[i].enabled = false;
				}
			}
		}
		else {
			foreach (Image img in inputArray) {
				img.enabled = false;
			}
		}
	}

	IEnumerator JumpToBottom() {
		yield return new WaitForSeconds(0.05f);

		GameObject.Find("Camera").GetComponent<HandyCameraMovement>().jumpToNewestMessage();
	}
}
