﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CTRL : MonoBehaviour {

	public enum GameState {Begin, Game, End};
	public GameState gameState;

	public enum PersonState {Excited, Sad, Listening, Talking, Waiting};
	public PersonState herState;
	public PersonState hisState;

	public float herLove;
	public float herAttention;
	public float tresholdGameOver;
	public float tresholdAnnoyed;
	public float tresholdInterested;
	public float tresholdAttached;
	public float tresholdInLove;
	public float tresholdWin;
	public string herPhase = "uninterested";

	[Header("Messages")]
	public Message[] messages;

	public Sprite interupt;
	public float scoreInterupt;
	public float scoreDifLargeRisky;
	public float scoreDifSmallRisky;
	public float scorePerfectRisky;
	public float scoreDifLarge;
	public float scoreDifSmall;
	public float scorePerfect;

	public Sprite faceConcentrated;
	public Sprite faceSad;
	public Sprite faceNormal;
	//reaction to talking
	public Sprite faceScrew;		//-1
	public Sprite faceSmiling;		//1
	//reaction to joke
	public Sprite faceEyeRoll;		//-1
	public Sprite faceLaughing;		//1
	//reaction to flirt
	public Sprite faceConfused;		//-1
	public Sprite faceFlattered;	//1

	[Header("States")]
	public float beat;
	public int action;
	public int reaction;
	public int spotting;
	public int boring;
	public int herTalking;
	public int himTalking;
	[HideInInspector] public int actionCounter = 0;
	[HideInInspector] public int reactionCounter = 0;
	[HideInInspector] public int spottingCounter = 0;
	[HideInInspector] public int boringCounter = 0;
	[HideInInspector] public int herTalkingCounter = 0;
	[HideInInspector] public int himTalkingCounter = 0;
	[HideInInspector] public int interuptCounter = 0;

	int interuptions = 0;
	int confusens = 0;
	int borensCounter = 0;
	int borens = 0;
	bool notGood = false;
	bool flowersGiven = false;

	public bool win = false;
	public bool gameOver = false;
	public bool lookAtPhone = false;
	public bool bored = false;
	public bool heTalked = false;

	public string input;
	public string command;

	public SpriteManager her;
	public SpriteManagerHim him;

	public Transform particlePos;
	public ParticleSystem attention;
	public ParticleSystem hearts;
	public ParticleSystem clouds;

	public List<Sprite> sprites;
	public string chars;
	public Dictionary<char, Sprite> spritesDictionary;

	// Use this for initialization
	void Start () {
		spritesDictionary = new Dictionary<char, Sprite>();

		for (int i = 0; i < sprites.Count; i++) {
			if (i < chars.Length) {
				spritesDictionary.Add(chars[i], sprites[i]);
			}
		}

		if (gameState == GameState.Game) {
			herState = PersonState.Excited;
			hisState = PersonState.Excited;
			herTalkingCounter = herTalking;
			her.ChangeSprites("uninterested", faceConcentrated);
			her.SetTalking(true);

			StartCoroutine("AtBeat");
		}
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		
	}

	public void ChangeGameStateToGame() {
		gameState = GameState.Game;
		herState = PersonState.Excited;
		hisState = PersonState.Excited;
		herTalkingCounter = herTalking;
		her.ChangeSprites("uninterested", faceConcentrated);
		her.SetTalking(true);

		StartCoroutine("AtBeat");
	}

	public void GetInput(string inputFromPhone) {
		input = inputFromPhone;
	}

	IEnumerator AtBeat() {
		yield return new WaitForSeconds(beat);

		if (gameState == CTRL.GameState.Game) {
			#region counters
			if (actionCounter > 0) {
				actionCounter--;
				bored = false;
				boringCounter = 0;
				
				//she reacts to him
				if (actionCounter == 0) {
					if (command != "confused") {
						Debug.Log("isn't confused");
						float scoring;
						bool himChange = true;

						if (command == "wink" || command == "kiss" || command == "flowers" || command == "magic" || command == "foot" || command == "joke" || command == "dick") {
							scoring = EvaluateAction(command, true);
							Debug.Log(command + " score: " + scoring);
						}
						else {
							scoring = EvaluateAction(command, false);
//							Debug.Log(command + " score: " + scoring);
						}
						
						//Debug.Log(scoring);
						AddScore(scoring);
						
						if (scoring == -100) {
							her.ChangeSprites("gameOver", null);
						}
						if (scoring < 0) {
							if (command == "joke") {
								her.ChangeSprites(herPhase, faceEyeRoll);
							}
							else if (command == "wink" || command == "kiss" || command == "flowers" || command == "magic" || command == "foot" || command == "dick") {
								her.ChangeSprites(herPhase, faceConfused);
							}
							else {
								her.ChangeSprites(herPhase, faceScrew);
							}
						}
						else {
							if (command == "joke") {
								her.ChangeSprites(herPhase, faceLaughing);
							}
							else if (command == "wink" || command == "kiss" || command == "flowers" || command == "magic" || command == "foot") {
								if (command == "kiss") {
									himChange = false;
									her.ChangeSprites("win", null);
									her.SetTalking(false);
									Sound.play.win.Play();
									GameObject.Find("Endings").GetComponent<Endings>().Kiss();
									gameState = CTRL.GameState.End;
								}
								else {
									her.ChangeSprites(herPhase, faceFlattered);
								}
							}
							else {
								her.ChangeSprites(herPhase, faceSmiling);
							}
						}
						
						reactionCounter = reaction;

						if (himChange) {
							him.SetTalking(false);
						}
					}
					else {
						him.SetTalking(false);
						if (herState == PersonState.Sad || herState == PersonState.Excited) {
							if (hisState == PersonState.Excited) him.ChangeSprites("concentrated");
							else him.ChangeSprites("sad");
						}
						else {
							him.ChangeSprites("waiting");
						}
					}
					
					command = "";
				}
			}
			else if (reactionCounter > 0) {
				reactionCounter--;
				
				//back to normal
				if (reactionCounter == 0) {
					BackToNormal();
					heTalked = true;
				}
			}
			else if (spottingCounter > 0) {
				spottingCounter--;
				
				//back to normal
				if (spottingCounter == 0) {
					BackToNormal();
				}
			}
			else if (interuptCounter > 0) {
				interuptCounter--;
				
				//back to normal
				if (interuptCounter == 0) {
					BackToNormal();
				}
			}
			
			if (boringCounter > 0) {
				boringCounter--;
				
				//she gets bored
				if (boringCounter == 0) {
					bored = true;
					borensCounter = 6;
					borens = 0;
					//BackToNormal();
				}
			}
			if (bored && borensCounter > 0) {
				borensCounter--;
				if (borensCounter == 0) {
					if (borens == 0) {
						StartCoroutine(FriendSendsMessage("What should I do???", 0.5f));
						borens++;
					}
					else {
						switch (borens) {
						case 1: StartCoroutine(FriendSendsMessage("Plz help me!", 0.5f)); break;
						case 2: StartCoroutine(FriendSendsMessage("What should I do?", 0.5f)); break;
						case 3: StartCoroutine(FriendSendsMessage("DUDE!", 0.5f)); StartCoroutine(FriendSendsMessage("I NEED U!", 1f)); break;
						case 4: StartCoroutine(FriendSendsMessage("ur k?", 0.5f)); break;
						case 5: StartCoroutine(FriendSendsMessage("COM ON!!!", 0.5f)); break;
						case 6: StartCoroutine(FriendSendsMessage("U FOR REAL?!?!?!", 0.5f)); break;
						case 7: StartCoroutine(FriendSendsMessage("I HATE U!!!", 0.5f)); break;
						default: break;
						}
						borens++;
					}
					borensCounter = 6;
				}
			}
			
			if (herTalkingCounter > 0 && interuptCounter == 0) {
				herTalkingCounter--;
			}
			if (himTalkingCounter > 0) {
				himTalkingCounter--;
				
				float scoring = EvaluateAction(command, false);
				//Debug.Log(scoring);
				AddScore(scoring);
				her.UpdateBody(herPhase);
				
				if (himTalkingCounter == 0) {
					him.ChangeSprites("waiting");
					heTalked = true;
					command = "";
				}
			}
			#endregion
			
			if (actionCounter == 0 && reactionCounter == 0 && spottingCounter == 0 && interuptCounter == 0) {
				if (himTalkingCounter == 0) {
					bool ignoreThisTime = false;
					#region player input
					//looks at phone
					if (input != "" && command == "" && !lookAtPhone) {
						lookAtPhone = true;
						ignoreThisTime = true;
						command = GetCommand(input);
						input = "";
						
						him.ChangeSprites("lookAtPhone");
						//Debug.Log("look at phone");
					}
					#endregion
					
					#region he acts
					//makes action of phone
					if (lookAtPhone && !ignoreThisTime) {
						lookAtPhone = false;
						Debug.Log("herstate " + herState);
						Debug.Log(command);
						
						//during her talking
						if (herState == PersonState.Excited || herState == PersonState.Sad) {
							//interuption
							if (!(command == "concentrated" || command == "sad")) {			//INTERUPTION
								if (interuptions < 2) {
									her.ChangeSprites(herPhase, interupt);
									him.ChangeSprites("interupt");
									interuptCounter = 2;
									AddScore(scoreInterupt);

									if (interuptions == 0) {
										StartCoroutine(FriendSendsMessage("Shit!", 1.5f));
										StartCoroutine(FriendSendsMessage("I think I shouldn't \ninterrupt her", 4f));
										StartCoroutine(FriendSendsMessage("When she talks just \nsay how I should look", 5f));
									}
									else {
										StartCoroutine(FriendSendsMessage("Dude ur confusing me!", 1.5f));
										StartCoroutine(FriendSendsMessage("I interrupted her again...", 3f));
										StartCoroutine(FriendSendsMessage("Just say if I should \nlook happy or sad!", 4f));
									}
									interuptions++;
									command = "";
								}
								else {
									command = "confused";
									Debug.Log("confused " + command);
									him.ChangeSprites(command);
									actionCounter = action;
									interuptions++;

									switch (interuptions) {
									case 2: StartCoroutine(FriendSendsMessage("Dont let me down!", 1.5f)); break;
									case 3: StartCoroutine(FriendSendsMessage("wtf dude!!!", 1.5f)); break;
									case 4: StartCoroutine(FriendSendsMessage("Plz dnt distarct me", 1.5f)); break;
									case 5: StartCoroutine(FriendSendsMessage("WTF ARE U DOING \nTO ME?!?!?!", 1.5f)); break;
									case 6: StartCoroutine(FriendSendsMessage("ASROLHE!", 1.5f)); break;
									default: StartCoroutine(FriendSendsMessage("?!?!?!?!", 1.5f)); break;
									}
								}
							}
							else {
								him.ChangeSprites(command);
								if (command == "concentrated") {							//CHANGE TO MOOD
									hisState = PersonState.Excited;
								}
								else {
									hisState = PersonState.Sad;
								}
								//command = "";
								bored = false;
								boringCounter = 0;
								command = "";
							}
						}
						//during her NOT talking
						else {
							if (command == "weather" || command == "hobby" || command == "sentimental" || command == "weather" || command == "compliment") {
								him.ChangeSprites(command);
								himTalkingCounter = himTalking;
								if (command == "sentimental") {
									her.ChangeSprites(herPhase, faceSad);
								}
								else if (command == "compliment") {
									her.ChangeSprites(herPhase, faceFlattered);
								}
								else {
									her.ChangeSprites(herPhase, faceConcentrated);
								}
								
								bored = false;
								boringCounter = 0;
							}
							else {
								if (command == "concentrated") {
									hisState = PersonState.Excited;
									//him.ChangeSprites(command);
									command = "";
									him.ChangeSprites("waiting");
								}
								else if (command == "sad") {
									hisState = PersonState.Sad;
									//him.ChangeSprites(command);
									command = "";
									him.ChangeSprites("waiting");
								}
								else {
									Debug.Log("flirt: " + command);
									
									if (command != "") {
										//flirt flowers
										if (command == "flowers") {
											if (!flowersGiven) {
												flowersGiven = true;
											}
											else {
												command = "confused";
												him.ChangeSprites(command);
												actionCounter = action;

												if (Random.value < 0.5f) StartCoroutine(FriendSendsMessage("I already gave \nher the flowers", 1.5f));
												else StartCoroutine(FriendSendsMessage("I have no \nmore flowers!", 1.5f));
											}
										}

										//other flirts
										him.ChangeSprites(command);
										actionCounter = action;
										bored = false;
										boringCounter = 0;
									}
									else {
										command = "confused";
										him.ChangeSprites(command);
										actionCounter = action;
										confusens++;

										switch(confusens) {
										case 0: StartCoroutine(FriendSendsMessage("What do u mean?", 1.5f)); break;
										case 1: StartCoroutine(FriendSendsMessage("Just scroll up the \nchat if you forgot\n our code!", 1.5f)); break;
										case 2: StartCoroutine(FriendSendsMessage("PLZ MAN!", 1.5f)); StartCoroutine(FriendSendsMessage("Dont let me down!", 2f)); break;
										case 3: StartCoroutine(FriendSendsMessage("STOP SENDING NONESENSE!", 1.5f)); StartCoroutine(FriendSendsMessage(">:C", 2.5f)); break;
										case 4: StartCoroutine(FriendSendsMessage("WTF!!!!!", 1.5f)); StartCoroutine(FriendSendsMessage("WHAT HAVE I \nDONE TO U?!?!", 2f)); break;
										case 5: StartCoroutine(FriendSendsMessage("PLZ JUST GO!", 1.5f)); break;
										default: 
											if (Random.value < 0.5f) StartCoroutine(FriendSendsMessage("?!?!?!", 1.5f));
											else StartCoroutine(FriendSendsMessage("...!", 1.5f));
											break;
										}
									}
								}
							}
						}
					}
					#endregion
					
					ignoreThisTime = false;
				}
				
				if (!lookAtPhone) {
					//if she is talking
					if (herState == PersonState.Excited || herState == PersonState.Sad) {
						if (Random.Range(0,100) < 5) {					//CHANGE TO SPOTTING
							spottingCounter = spotting;
							her.ChangeSprites("spotting", null);
							her.SetTalking(false);
						}
						else if (Random.Range(0, 100) < 5) {			//CHANGE MOOD
							Sprite spr;
							if (herState == PersonState.Excited) {
								herState = PersonState.Sad;
								spr = faceSad;
							}
							else {
								herState = PersonState.Excited;
								spr = faceConcentrated;
							}
							her.ChangeSprites(herPhase, spr);
							her.SetTalking(true);
						}
						else if (herTalkingCounter == 0 && Random.Range(0, 100) < 40) {		//STOP TALKING
							herState = PersonState.Listening;
							her.ChangeSprites(herPhase, null);
							her.SetTalking(false);
							boringCounter = boring;
						}
						else {
							if (herState != hisState) {
								//Debug.Log(-1);
								AddScore(-1);
								her.UpdateBody(herPhase);
							}
						}
					}
					//she is listening
					else {
						if (!heTalked && bored && himTalkingCounter == 0) {					//BORED
							//Debug.Log(-1);
							AddScore(-1);
							her.UpdateBody(herPhase);
						}
						else if (heTalked) {												//START TALKING
							herTalkingCounter = herTalking;
							her.SetTalking(true);
							
							if (Random.Range(0, 100) < 40) {
								herState = PersonState.Sad;
								her.ChangeSprites(herPhase, faceSad);
							}
							else {
								herState = PersonState.Excited;
								her.ChangeSprites(herPhase, faceConcentrated);
							}
							
							if (hisState == PersonState.Excited) {
								him.ChangeSprites("concentrated");
							}
							else {
								him.ChangeSprites("sad");
							}
							
							heTalked = false;
						}
					}
				}
			}
			
			StartCoroutine("AtBeat");
		}
	}

	string GetCommand(string input) {
		string ret = "";

		for (int i = 0; i < messages.Length; i++) {
			if (messages[i].emojis == input) {
				ret = messages[i].name;
			}
		}
			
		return ret;
	}

	void AddScore(float score) {
		//Debug.Log(score);
		herLove += score;

		if (herLove > tresholdWin) {
			Debug.Log("Win!");
			her.ChangeSprites("win", null);
			her.SetTalking(false);
			Sound.play.win.Play();
			GameObject.Find("Endings").GetComponent<Endings>().Win();
			gameState = CTRL.GameState.End;
		}
		else if (herLove > tresholdInLove) {
			herPhase = "inLove";
		}
		else if (herLove > tresholdAttached) {
			herPhase = "attached";
		}
		else if (herLove > tresholdInterested) {
			herPhase = "interested";
		}
		else if (herLove > 0) {
			herPhase = "uninterested";
		}
		else if (herLove > tresholdAnnoyed) {
			herPhase = "annoyed";
			if (!notGood) {
				StartCoroutine(FriendSendsMessage("I think she hates \nme :(", 1));
				StartCoroutine(FriendSendsMessage("Plz help dude!", 2));
				notGood = true;
			}
		}
		else {
			Debug.Log("Game Over!");
			her.ChangeSprites("gameOver", null);
			her.SetTalking(false);
			Sound.play.lose.Play();
			GameObject.Find("Endings").GetComponent<Endings>().Lose();
			gameState = CTRL.GameState.End;
		}

		if (score < 0) {
			if (Mathf.Abs(score) > 50) score = 50;

			for (int i = 0; i < (int) Mathf.Abs(score); i++) {
				ParticleSystem ps = Instantiate(clouds, particlePos) as ParticleSystem;
				ps.transform.localPosition = Vector3.zero;
			}
			/*clouds.transform.localPosition = new Vector3(0.1f, 0.3f, 0);
			clouds.Emit((int) Mathf.Abs(score));*/
		}
		else {
			if (Mathf.Abs(score) > 50) score = 50;

			for (int i = 0; i < (int) score; i++) {
				ParticleSystem ps = Instantiate(hearts, particlePos) as ParticleSystem;
				ps.transform.localPosition = Vector3.zero;
			}
		}
	}

	void BackToNormal() {
		//if she is talking
		if (herState == PersonState.Excited || herState == PersonState.Sad) {
			if (hisState == PersonState.Excited) {
				him.ChangeSprites("concentrated");
			}
			else if (hisState == PersonState.Sad) {
				him.ChangeSprites("sad");
			}

			if (herState == PersonState.Excited) {
				her.ChangeSprites(herPhase, faceConcentrated);
			}
			else if (herState == PersonState.Sad) {
				her.ChangeSprites(herPhase, faceSad);
			}

			her.SetTalking(true);
		}
		else {
			him.ChangeSprites("waiting");

			her.ChangeSprites(herPhase, faceNormal);

			her.SetTalking(false);
		}
	}

	float EvaluateAction (string actionFromHim, bool risky) {
		float ret = 0f;

		int messageIndex, messageIndex2, herIndex, phaseDifference;
		messageIndex = 0;
		messageIndex2 = 0;
		herIndex = 0;

		for (int i = 0; i < messages.Length; i++) {
			if (messages[i].name == actionFromHim) {
				messageIndex = (int) messages[i].optimalPhase.x;
				messageIndex2 = (int) messages[i].optimalPhase.y;
			}
		}
			
		switch (herPhase) {
		case "annoyed": herIndex = -1; break;
		case "uninterested": herIndex = 0; break;
		case "interested": herIndex = 1; break;
		case "attached": herIndex = 2; break;
		case "inLove": herIndex = 3; break;
		}

		phaseDifference = herIndex - messageIndex;
		if (phaseDifference < 0) {
			if (Mathf.Abs(herIndex - messageIndex2) < Mathf.Abs(phaseDifference)) {
				phaseDifference = herIndex - messageIndex2;
				Debug.Log("pahseDifference2 = " + herIndex + " - " + messageIndex2 + " = " + phaseDifference);
			}
			else {
				Debug.Log("pahseDifference = " + herIndex + " - " + messageIndex + " = " + phaseDifference);
			}
		}

		if (actionFromHim == "dick") {
			ret = -1000;
		}
		else if (phaseDifference <= -3) {
			if (risky) ret = -100;
			else ret = -10;
		}
		else if (phaseDifference == -2) {
			if (risky) ret = -scoreDifLargeRisky;
			else ret = scoreDifSmall;
		}
		else if (phaseDifference == -1) {
			if (risky) ret = -scoreDifSmallRisky;
			else ret = scoreDifLarge;
		}
		//perfect
		else if (phaseDifference == 0) {
			if (risky) ret = scorePerfectRisky;
			else ret = scorePerfect;
		}
		else if (phaseDifference == 1) {
			if (risky) ret = scoreDifLargeRisky;
			else ret = scoreDifLarge;
		}
		else if (phaseDifference == 2) {
			if (risky) ret = scoreDifSmallRisky;
			else ret = scoreDifSmall;
		}
		else {
			if (risky) ret = -scoreDifSmallRisky;
			else ret = -scoreDifSmall;
		}
			
		return ret;
	}

	public void AttentionParticle() {
		ParticleSystem ps = Instantiate(attention, particlePos) as ParticleSystem;
		ps.transform.localPosition = Vector3.zero;
	}

	public IEnumerator FriendSendsMessage(string mes, float wait) {
		yield return new WaitForSeconds(wait);

		//Debug.Log("send: " + mes);
		GameObject.Find("ChatDisplay").GetComponent<ChatManager_v2>().createMessage(mes, "friend");
		StartCoroutine("JumpToBottom");
	}

	IEnumerator JumpToBottom() {
		yield return new WaitForSeconds(0.05f);

		GameObject.Find("Camera").GetComponent<HandyCameraMovement>().jumpToNewestMessage();
	}
}
