﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpriteManager : MonoBehaviour {

	public Sprite sprGameOver;
	public Sprite sprAnnoyed;
	public Sprite sprUninterested;
	public Sprite sprInterested;
	public Sprite sprAttached;
	public Sprite sprInLove;
	public Sprite sprWin;
	public Sprite sprKiss;

	public Sprite sprSpotting;
	public Sprite sprSpotted;

	public Transform faceGameOver;
	public Transform faceAnnoyed;
	public Transform faceUninterested;
	public Transform faceInterested;
	public Transform faceAttached;
	public Transform faceInLove;
	public Transform faceWin;

	public Transform face;
	public Transform mouth;

	public float talkingTime;
	public Sprite[] mouths;
	int mouthCounter = 0;
	bool talking = true;

	public SpriteRenderer sr;

	// Use this for initialization
	void OnEnable () {
		sr = GetComponent<SpriteRenderer>();
		//face.gameObject.SetActive(false);
		//mouth.gameObject.SetActive(false);
	}

	void Start() {
		face.position = faceUninterested.position;
		face.rotation = faceUninterested.rotation;
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		
	}

	public void ChangeSprites(string phase, Sprite sprFace) {

		//face.gameObject.SetActive(true);
		face.GetComponent<SpriteRenderer>().enabled = true;

		if (sprFace != null) {
			face.GetComponent<SpriteRenderer>().sprite = sprFace;
		}
		else {
			//face.gameObject.SetActive(false);
			face.GetComponent<SpriteRenderer>().enabled = false;
		}

		UpdateBody(phase);
	}

	public void UpdateBody(string phase) {
		switch (phase) {
		case "gameOver": 
			face.position = faceGameOver.position; 
			face.rotation = faceGameOver.rotation;
			sr.sprite = sprGameOver;
			break;
		case "annoyed": 
			face.position = faceAnnoyed.position; 
			face.rotation = faceAnnoyed.rotation;
			sr.sprite = sprAnnoyed;
			break;
		case "uninterested": 
			face.position = faceUninterested.position; 
			face.rotation = faceUninterested.rotation;
			sr.sprite = sprUninterested;
			break;
		case "interested": 
			face.position = faceInterested.position;
			face.rotation = faceInterested.rotation;
			sr.sprite = sprInterested;
			break;
		case "attached": 
			face.position = faceAttached.position; 
			face.rotation = faceAttached.rotation;
			sr.sprite = sprAttached;
			break;
		case "inLove": 
			face.position = faceInLove.position; 
			face.rotation = faceInLove.rotation;
			sr.sprite = sprInLove;
			break;
		case "win": 
			face.position = faceWin.position; 
			face.rotation = faceWin.rotation;
			sr.sprite = sprWin;
			break;
		case "kiss": 
			face.position = faceWin.position; 
			face.rotation = faceWin.rotation;
			face.GetComponent<SpriteRenderer>().enabled = false;
			SetTalking(false);
			sr.sprite = sprKiss;
			break;
		case "spotting":
			//face.gameObject.SetActive(false);
			face.GetComponent<SpriteRenderer>().enabled = false;
			SetTalking(false);
			sr.sprite = sprSpotting;
			break;
		case "spotted":
			//face.gameObject.SetActive(false);
			face.GetComponent<SpriteRenderer>().enabled = false;
			SetTalking(false);
			sr.sprite = sprSpotted;
			break;
		}
	}

	public void SetTalking (bool active) {
		talking = active;

		mouth.gameObject.SetActive(talking);

		if (talking) {

			if (face != mouth) mouth.GetComponent<SpriteRenderer>().sprite = mouths[0];
			mouthCounter = 0;

			StartCoroutine("ChangeMouth");
		}
	}

	IEnumerator ChangeMouth() {
		yield return new WaitForSeconds(talkingTime);

		mouthCounter = Random.Range(0, mouths.Length);

		mouth.GetComponent<SpriteRenderer>().sprite = mouths[mouthCounter];

		if (talking) {
			StartCoroutine("ChangeMouth");
		}
	}
}
