﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpriteManagerHim : MonoBehaviour {

	public Sprite sprLookAtPhone;
	public Sprite sprNormal;
	public Sprite sprConcentrated;
	public Sprite sprSad;
	public Sprite sprTalk;
	public Sprite sprCompliment;
	public Sprite sprSentimental;
	public Sprite sprFlowers;
	public Sprite sprWink;
	public Sprite sprKiss;
	public Sprite sprMagic;
	public Sprite sprAsk;
	public Sprite sprInterupt;
	public Sprite sprDick;
	public Sprite sprJoke;
	public Sprite sprFoot;
	public Sprite sprConfused;

	public Transform mouthNormal;
	public Transform mouthSentimental;
	public Transform mouthCompliment;
	public Transform mouthAsk;
	public Transform mouthJoke;
	public Transform mouthDick;
	public Transform mouthKiss;

	public Transform mouth;

	public float talkingTime;
	public Sprite[] mouths;
	int mouthCounter = 0;
	bool talking = true;

	public SpriteRenderer sr;

	// Use this for initialization
	void OnEnable () {
		sr = GetComponent<SpriteRenderer>();
		mouth.gameObject.SetActive(false);
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	public void ChangeSprites(string phase) {

		SetTalking(false);
		mouth.position = mouthNormal.position;
		mouth.rotation = mouthNormal.rotation;

		switch (phase) {
		case "lookAtPhone": 
			sr.sprite = sprLookAtPhone;
			break;
		case "waiting": 
			sr.sprite = sprNormal;
			break;
		case "normal": 
			sr.sprite = sprNormal;
			SetTalking(true);
			break;
		case "weather": 
			sr.sprite = sprNormal;
			SetTalking(true);
			break;
		case "hobby": 
			sr.sprite = sprNormal;
			SetTalking(true);
			break;
		case "joke": 
			sr.sprite = sprJoke;
			mouth.position = mouthJoke.position;
			mouth.rotation = mouthJoke.rotation;
			SetTalking(true);
			break;
		case "dick": 
			sr.sprite = sprDick;
			mouth.position = mouthDick.position;
			mouth.rotation = mouthDick.rotation;
			SetTalking(true);
			break;
		case "ask":
			sr.sprite = sprAsk;
			if (mouth != null) mouth.position = mouthAsk.position;
			mouth.rotation = mouthAsk.rotation;
			SetTalking(true);
			break;
		case "wink": 
			sr.sprite = sprWink;
			break;
		case "concentrated": 
			sr.sprite = sprConcentrated;
			break;
		case "sad": 
			sr.sprite = sprSad;
			break;
		case "compliment": 
			sr.sprite = sprCompliment;
			if (mouth != null) mouth.position = mouthCompliment.position;
			mouth.rotation = mouthCompliment.rotation;
			SetTalking(true);
			break;
		case "sentimental": 
			sr.sprite = sprSentimental;
			if (mouth != null) mouth.position = mouthSentimental.position;
			mouth.rotation = mouthSentimental.rotation;
			SetTalking(true);
			break;
		case "flowers": 
			sr.sprite = sprFlowers;
			break;
		case "kiss": 
			mouth.position = mouthKiss.position;
			mouth.rotation = mouthKiss.rotation;
			sr.sprite = sprKiss;
			break;
		case "magic": 
			sr.sprite = sprMagic;
			break;
		case "interupt": 
			sr.sprite = sprInterupt;
			break;
		case "foot": 
			sr.sprite = sprFoot;
			break;
		case "confused":
			sr.sprite = sprConfused;
			break;
		}
	}

	public void SetTalking (bool active) {
		talking = active;

		mouth.gameObject.SetActive(talking);

		if (talking) {

			mouth.GetComponent<SpriteRenderer>().sprite = mouths[0];
			mouthCounter = 0;

			StartCoroutine("ChangeMouth");
		}
	}

	IEnumerator ChangeMouth() {
		yield return new WaitForSeconds(talkingTime);

		mouthCounter = Random.Range(0, mouths.Length);

		mouth.GetComponent<SpriteRenderer>().sprite = mouths[mouthCounter];

		if (talking) {
			StartCoroutine("ChangeMouth");
		}
	}
}
